<template>
  <AppSelect
    :value="selectedItem"
    track-by="id"
    placeholder="Сортировать"
    :classes="['multiselectSorting']"
    :searchable="false"
    :options="options"
    :has-clear="false"
    @select="onSelect">
    <div
      slot="singleLabel"
      slot-scope="{ option }"
      class="sorting">
      <span class="__black">Сортировать&nbsp;</span>
      <span>
        {{ option.titleMobile }}
        <span
          :class="sortClass(option.direction)"
          class="sorting-direction">
          <img
            svg-inline
            src="~/assets/svg/redesign/sorting-down-mobile.svg">
        </span>
      </span>
    </div>

    <div
      class="sorting"
      slot="option"
      slot-scope="{ option }">
      {{ option.titleMobile }}
      <span
        :class="sortClass(option.direction)"
        class="sorting-direction">
        <img
          svg-inline
          src="~/assets/svg/redesign/sorting-down-mobile.svg">
      </span>
    </div>
  </AppSelect>
</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';
import OrderDirections from '~/assets/js/enums/order-directions';

export default {
  name: 'SelectSorting',
  components: {
    AppSelect,
  },
  props: {
    options: {
      type: Array,
      default() {
        return [];
      },
    },
    value: {
      type: [String, Object, Array],
      default() { return null; },
    },
    isInitFirst: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      option: null,
    };
  },
  computed: {
    selectedItem() {
      if (this.value) return this.value;

      return this.option;
    },
  },
  created() {
    if (this.isInitFirst && this.options.length) {
      this.option = this.options[0];
    }
  },
  methods: {
    onSelect(entry) {
      this.$emit('order-change', entry);
      //  {
      //   field: entry.criteria,
      //   direction: entry.direction,
      // }
    },
    sortClass(direction) {
      return direction === OrderDirections.ASC ? '-sorting-up' : '-sorting-down';
    },
  },
};
</script>

<style lang="postcss">
  .multiselect.multiselectSorting {
    margin-top: 0.5rem;
    font-size: 1rem;

    .multiselect {
      &__tags {
        padding-left: 0;
        border: none;
        box-shadow: none;
      }

      &__content-wrapper {
        left: auto;
        right: 0;
        width: 15rem;
        margin-top: -0.625rem;
        border-top: 1px solid var(--border-color-main);
        border-radius: 0;
      }
    }

    .sorting {
      display: flex;
      justify-content: flex-end;
      align-items: center;
      color: var(--color-main-lightest);

      &-direction {
        margin: 0.125rem 0.375rem 0 0.375rem;

        &.-sorting-up {
          .svg {
            transform: rotate(180deg);
          }
        }
      }
    }

    @media screen and (max-width: 374px) {
      font-size: 0.875rem;
    }
  }
</style>
